"
 COPYRIGHT (c) 2004 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

"{ Package: 'stx:libbasic' }"

ExternalFunction subclass:#ExternalLibraryFunction
	instanceVariableNames:'flags moduleName callType returnType argumentTypes'
	classVariableNames:''
	poolDictionaries:''
	category:'System-Support'
!

!ExternalLibraryFunction class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2004 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!ExternalLibraryFunction class methodsFor:'instance creation'!

name:functionName module:moduleName callType:callType 
                  returnType:returnType argumentTypes:argTypes
    ^ self new
        name:functionName module:moduleName callType:callType 
        returnType:returnType argumentTypes:argTypes
! !

!ExternalLibraryFunction methodsFor:'invoking'!

invoke

    moduleHandle isNil ifTrue:[
        self linkToModule.
        self setupFFI.
    ].

    ^ self invokeFFI
!

invokeWith:arg

    moduleHandle isNil ifTrue:[
        self linkToModule.
        self setupFFI.
    ].

    ^ self invokeFFI

    "
        self new test:'abc'
    "
! !

!ExternalLibraryFunction methodsFor:'private'!

invokeFFI
    "invoke foreign function interface"
!

linkToModule
    "link this function to the external module.
     I.e. retrieve the module handle and the code pointer."

    |handle code|

    handle := ObjectFileLoader moduleNamed:moduleName.
    handle isNil ifTrue:[
        self error:'cannot load: ', moduleName.
    ].
    moduleHandle := handle.
    code := moduleHandle getFunctionAddress:name into:self.
    code isNil ifTrue:[
        self error:'cannot load function: ', name, ' in module: ', moduleName.
    ].
!

setupFFI
    "setup foreign function interface"

"
ffi_prep_cif(&cif, FFI_DEFAULT_ABI, 1,
                       &ffi_type_uint, args) == FFI_OK

"
! !

!ExternalLibraryFunction methodsFor:'private-accessing'!

name:functionName module:aModuleName callType:aCallType returnType:aReturnType argumentTypes:argTypes 
    name := functionName.
    moduleName := aModuleName.
    callType := aCallType.
    returnType := aReturnType.
    argumentTypes := argTypes.
! !

!ExternalLibraryFunction class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libbasic/ExternalLibraryFunction.st,v 1.4 2005-06-21 13:17:59 stefan Exp $'
! !
